gi-gdk4-4.0.10: Gdk bindings

Copyright | Will Thompson and Iñaki García Etxebarria
License | LGPL-2.1
Maintainer | Iñaki García Etxebarria
Safe Haskell | None
Language | Haskell2010

GI.Gdk.Objects.Seat

Contents

- Exported types
- Methods
  - getCapabilities
  - getDevices
  - getDisplay
  - getKeyboard
  - getPointer
  - getTools
- Properties
  - display
- Signals
  - deviceAdded
  - deviceRemoved
  - toolAdded
  - toolRemoved

Description

Represents a collection of input devices that belong to a user.

Synopsis

- newtype Seat = Seat (ManagedPtr Seat)
- class (GObject o, IsDescendantOf Seat o) => IsSeat o
- toSeat :: (MonadIO m, IsSeat o) => o -> m Seat
- seatGetCapabilities :: (HasCallStack, MonadIO m, IsSeat a) => a -> m [SeatCapabilities]
- seatGetDevices :: (HasCallStack, MonadIO m, IsSeat a) => a -> [SeatCapabilities] -> m [Device]
- seatGetDisplay :: (HasCallStack, MonadIO m, IsSeat a) => a -> m Display
- seatGetKeyboard :: (HasCallStack, MonadIO m, IsSeat a) => a -> m (Maybe Device)
- seatGetPointer :: (HasCallStack, MonadIO m, IsSeat a) => a -> m (Maybe Device)
- seatGetTools :: (HasCallStack, MonadIO m, IsSeat a) => a -> m [DeviceTool]
- constructSeatDisplay :: (IsSeat o, MonadIO m, IsDisplay a) => a -> m (GValueConstruct o)
- getSeatDisplay :: (MonadIO m, IsSeat o) => o -> m Display
- type SeatDeviceAddedCallback = Device -> IO ()
- afterSeatDeviceAdded :: (IsSeat a, MonadIO m) => a -> ((?self :: a) => SeatDeviceAddedCallback) -> m SignalHandlerId
- onSeatDeviceAdded :: (IsSeat a, MonadIO m) => a -> ((?self :: a) => SeatDeviceAddedCallback) -> m SignalHandlerId
- type SeatDeviceRemovedCallback = Device -> IO ()
- afterSeatDeviceRemoved :: (IsSeat a, MonadIO m) => a -> ((?self :: a) => SeatDeviceRemovedCallback) -> m SignalHandlerId
- onSeatDeviceRemoved :: (IsSeat a, MonadIO m) => a -> ((?self :: a) => SeatDeviceRemovedCallback) -> m SignalHandlerId
- type SeatToolAddedCallback = DeviceTool -> IO ()
- afterSeatToolAdded :: (IsSeat a, MonadIO m) => a -> ((?self :: a) => SeatToolAddedCallback) -> m SignalHandlerId
- onSeatToolAdded :: (IsSeat a, MonadIO m) => a -> ((?self :: a) => SeatToolAddedCallback) -> m SignalHandlerId
- type SeatToolRemovedCallback = DeviceTool -> IO ()
- afterSeatToolRemoved :: (IsSeat a, MonadIO m) => a -> ((?self :: a) => SeatToolRemovedCallback) -> m SignalHandlerId
- onSeatToolRemoved :: (IsSeat a, MonadIO m) => a -> ((?self :: a) => SeatToolRemovedCallback) -> m SignalHandlerId

# Exported types

newtype Seat Source #

Memory-managed wrapper type.

Constructors

Seat (ManagedPtr Seat) |

#### Instances

Instances details

Eq Seat Source # |
Instance details Defined in GI.Gdk.Objects.Seat Methods (==) :: Seat -> Seat -> Bool Source # (/=) :: Seat -> Seat -> Bool Source #
GObject Seat Source # |
Instance details Defined in GI.Gdk.Objects.Seat
ManagedPtrNewtype Seat Source # |
Instance details Defined in GI.Gdk.Objects.Seat Methods toManagedPtr :: Seat -> ManagedPtr Seat Source #
TypedObject Seat Source # |
Instance details Defined in GI.Gdk.Objects.Seat Methods glibType :: IO GType Source #
HasParentTypes Seat Source # |
Instance details Defined in GI.Gdk.Objects.Seat
IsGValue (Maybe Seat) Source # | Convert `Seat` to and from `GValue`. See `toGValue` and `fromGValue`.
Instance details Defined in GI.Gdk.Objects.Seat Methods gvalueGType_ :: IO GType Source # gvalueSet_ :: Ptr GValue -> Maybe Seat -> IO () Source # gvalueGet_ :: Ptr GValue -> IO (Maybe Seat) Source #
type ParentTypes Seat Source # |
Instance details Defined in GI.Gdk.Objects.Seat type ParentTypes Seat = '[Object]

class (GObject o, IsDescendantOf Seat o) => IsSeat o Source #

Type class for types which can be safely cast to `Seat`, for instance with `toSeat`.

#### Instances

Instances details

(GObject o, IsDescendantOf Seat o) => IsSeat o Source # |
Instance details Defined in GI.Gdk.Objects.Seat

toSeat :: (MonadIO m, IsSeat o) => o -> m Seat Source #

Cast to `Seat`, for types for which this is known to be safe. For general casts, use `castTo`.

# Methods

### Click to display all available methods, including inherited ones

Expand

#### Methods

bindProperty, bindPropertyFull, forceFloating, freezeNotify, getv, isFloating, notify, notifyByPspec, ref, refSink, runDispose, stealData, stealQdata, thawNotify, unref, watchClosure.

#### Getters

getCapabilities, getData, getDevices, getDisplay, getKeyboard, getPointer, getProperty, getQdata, getTools.

#### Setters

setData, setDataFull, setProperty.

## getCapabilities

seatGetCapabilities Source #

Arguments

:: (HasCallStack, MonadIO m, IsSeat a) |
=> a | `seat`: a `GdkSeat`
-> m [SeatCapabilities] | Returns: the seat capabilities

Returns the capabilities this `GdkSeat` currently has.

## getDevices

seatGetDevices Source #

Arguments

:: (HasCallStack, MonadIO m, IsSeat a) |
=> a | `seat`: a `GdkSeat`
-> [SeatCapabilities] | `capabilities`: capabilities to get devices for
-> m [Device] | Returns: A list of `GdkDevices`. The list must be freed with `g_list_free()`, the elements are owned by GTK and must not be freed.

Returns the devices that match the given capabilities.

## getDisplay

seatGetDisplay Source #

Arguments

:: (HasCallStack, MonadIO m, IsSeat a) |
=> a | `seat`: a `GdkSeat`
-> m Display | Returns: a `GdkDisplay`. This object is owned by GTK and must not be freed.

Returns the `GdkDisplay` this seat belongs to.

## getKeyboard

seatGetKeyboard Source #

Arguments

:: (HasCallStack, MonadIO m, IsSeat a) |
=> a | `seat`: a `GdkSeat`
-> m (Maybe Device) | Returns: a `GdkDevice` with keyboard capabilities. This object is owned by GTK and must not be freed.

Returns the device that routes keyboard events.

## getPointer

seatGetPointer Source #

Arguments

:: (HasCallStack, MonadIO m, IsSeat a) |
=> a | `seat`: a `GdkSeat`
-> m (Maybe Device) | Returns: a `GdkDevice` with pointer capabilities. This object is owned by GTK and must not be freed.

Returns the device that routes pointer events.

## getTools

seatGetTools Source #

Arguments

:: (HasCallStack, MonadIO m, IsSeat a) |
=> a | `seat`: a `GdkSeat`
-> m [DeviceTool] | Returns: A list of tools. Free with `g_list_free()`.

Returns all `GdkDeviceTools` that are known to the application.

# Properties

## display

`GdkDisplay` of this seat.

constructSeatDisplay :: (IsSeat o, MonadIO m, IsDisplay a) => a -> m (GValueConstruct o) Source #

Construct a `GValueConstruct` with valid value for the “`display`” property. This is rarely needed directly, but it is used by `new`.

getSeatDisplay :: (MonadIO m, IsSeat o) => o -> m Display Source #

Get the value of the “`display`” property. When overloading is enabled, this is equivalent to

    get seat #display

# Signals

## deviceAdded

type SeatDeviceAddedCallback Source #

Arguments

= Device | `device`: the newly added `GdkDevice`.
-> IO () |

Emitted when a new input device is related to this seat.

afterSeatDeviceAdded :: (IsSeat a, MonadIO m) => a -> ((?self :: a) => SeatDeviceAddedCallback) -> m SignalHandlerId Source #

Connect a signal handler for the deviceAdded signal, to be run after the default handler. When overloading is enabled, this is equivalent to

    after seat #deviceAdded callback

By default the object invoking the signal is not passed to the callback. If you need to access it, you can use the implit `?self` parameter. Note that this requires activating the `ImplicitParams` GHC extension.

onSeatDeviceAdded :: (IsSeat a, MonadIO m) => a -> ((?self :: a) => SeatDeviceAddedCallback) -> m SignalHandlerId Source #

Connect a signal handler for the deviceAdded signal, to be run before the default handler. When overloading is enabled, this is equivalent to

    on seat #deviceAdded callback

## deviceRemoved

type SeatDeviceRemovedCallback Source #

Arguments

= Device | `device`: the just removed `GdkDevice`.
-> IO () |

Emitted when an input device is removed (e.g. unplugged).

afterSeatDeviceRemoved :: (IsSeat a, MonadIO m) => a -> ((?self :: a) => SeatDeviceRemovedCallback) -> m SignalHandlerId Source #

Connect a signal handler for the deviceRemoved signal, to be run after the default handler. When overloading is enabled, this is equivalent to

    after seat #deviceRemoved callback

By default the object invoking the signal is not passed to the callback. If you need to access it, you can use the implit `?self` parameter. Note that this requires activating the `ImplicitParams` GHC extension.

onSeatDeviceRemoved :: (IsSeat a, MonadIO m) => a -> ((?self :: a) => SeatDeviceRemovedCallback) -> m SignalHandlerId Source #

Connect a signal handler for the deviceRemoved signal, to be run before the default handler. When overloading is enabled, this is equivalent to

    on seat #deviceRemoved callback

## toolAdded

type SeatToolAddedCallback Source #

Arguments

= DeviceTool | `tool`: the new `GdkDeviceTool` known to the seat
-> IO () |

Emitted whenever a new tool is made known to the seat.

The tool may later be assigned to a device (i.e. on proximity with a tablet). The device will emit the Device::toolChanged signal accordingly.

A same tool may be used by several devices.

afterSeatToolAdded :: (IsSeat a, MonadIO m) => a -> ((?self :: a) => SeatToolAddedCallback) -> m SignalHandlerId Source #

Connect a signal handler for the toolAdded signal, to be run after the default handler. When overloading is enabled, this is equivalent to

    after seat #toolAdded callback

By default the object invoking the signal is not passed to the callback. If you need to access it, you can use the implit `?self` parameter. Note that this requires activating the `ImplicitParams` GHC extension.

onSeatToolAdded :: (IsSeat a, MonadIO m) => a -> ((?self :: a) => SeatToolAddedCallback) -> m SignalHandlerId Source #

Connect a signal handler for the toolAdded signal, to be run before the default handler. When overloading is enabled, this is equivalent to

    on seat #toolAdded callback

## toolRemoved

type SeatToolRemovedCallback Source #

Arguments

= DeviceTool | `tool`: the just removed `GdkDeviceTool`
-> IO () |

Emitted whenever a tool is no longer known to this `seat`.

afterSeatToolRemoved :: (IsSeat a, MonadIO m) => a -> ((?self :: a) => SeatToolRemovedCallback) -> m SignalHandlerId Source #

Connect a signal handler for the toolRemoved signal, to be run after the default handler. When overloading is enabled, this is equivalent to

    after seat #toolRemoved callback

By default the object invoking the signal is not passed to the callback. If you need to access it, you can use the implit `?self` parameter. Note that this requires activating the `ImplicitParams` GHC extension.

onSeatToolRemoved :: (IsSeat a, MonadIO m) => a -> ((?self :: a) => SeatToolRemovedCallback) -> m SignalHandlerId Source #

Connect a signal handler for the toolRemoved signal, to be run before the default handler. When overloading is enabled, this is equivalent to

    on seat #toolRemoved callback